// FarCalc2Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "FarCalc2.h"
#include "FarCalc2Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFarCalc2Dlg dialog

CFarCalc2Dlg::CFarCalc2Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFarCalc2Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFarCalc2Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFarCalc2Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFarCalc2Dlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFarCalc2Dlg, CDialog)
	//{{AFX_MSG_MAP(CFarCalc2Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFarCalc2Dlg message handlers

UINT Listener(LPVOID pParam){
	char buf[2048];
	int a;
	CListBox *listbox=(CListBox*) pParam;
	CSocket *sock=new CSocket();
	if(!sock->Create(0,SOCK_DGRAM,"255.255.255.255:14753")){
		sprintf(buf,"Create: %d",GetLastError());
		listbox->AddString(buf);
		return 0;}
	while(1){
		a=sock->Receive(buf,2047);
		if(SOCKET_ERROR==a){
			sprintf(buf,"Recv: %d",a);
			listbox->AddString(buf);
			return 0;}
		buf[a]=0;
		listbox->AddString(buf);}
}

BOOL CFarCalc2Dlg::OnInitDialog()
{
	int argc=1;
	char *argv[]={"",NULL};
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
    orb = CORBA::ORB_init(argc,argv);
	
	AfxBeginThread(Listener,CDialog::GetWindow(IDC_LIST1));
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFarCalc2Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFarCalc2Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CFarCalc2Dlg::OnButton1() 
{	CString s;
	CORBA::Double a,b;
	char buf[100];
	// TODO: Add your control notification handler code here
	CEdit *ed=(CEdit*) CDialog::GetWindow(IDC_EDIT1);
	ed->GetWindowText(s);
	a=atof(s);
	ed=(CEdit*) CDialog::GetWindow(IDC_EDIT2);
	ed->GetWindowText(s);
	b=atof(s);

	CListBox *listbox=(CListBox*) CDialog::GetWindow(IDC_LIST1);
	listbox->GetText(listbox->GetCurSel(), s);
	CORBA::Object_var obj = orb->string_to_object(s);
    FarCalc_var ref = FarCalc::_narrow(obj);
	ed=(CEdit*) CDialog::GetWindow(IDC_EDIT3);
	sprintf(buf,"%E",ref->AddInt(a,b));
	ed->SetWindowText(buf);
}
